<?php

function _contextly_displayed_once($function) {
  static $displayed = array();
  $return = !empty($displayed[$function]);
  $displayed[$function] = TRUE;
  return $return;
}

/**
 * Returns HTML for the Contextly Related module.
 */
function theme_contextly_widget() {
  if (_contextly_displayed_once(__FUNCTION__)) {
    return '';
  }

  return '<div id="ctx-module" class="ctx-module-container ctx-clearfix"></div>';
}

function theme_contextly_storyline_subscribe() {
  if (_contextly_displayed_once(__FUNCTION__)) {
    return '';
  }

  return '<div id="ctx-sl-subscribe" class="ctx-clearfix"></div>';
}

function theme_contextly_metadata($metadata) {
  $attributes = array(
    'name' => 'contextly-page',
    'id' => 'contextly-page',
  );

  // All special characters are encoded inside JSON (<, >, ', &, and "). Double
  // quotes around JSON property names and values are fine here, because we use
  // single quotes around HTML attribute value.
  $metadata = _contextly_json_encode($metadata);
  return '<meta' . drupal_attributes($attributes) . " content='" . $metadata . "' />\n";
}

function theme_contextly_snippet_edit() {
  $output = '<input type="button" class="d-ctx-snippet-button form-submit" value="" />' . "\n";
  $output .= '<div class="d-ctx-snippet-status description"></div>' . "\n";
  $output = '<div class="d-ctx-snippet-edit" style="display: none;">' . $output . "</div>\n";
  return $output;
}
